package bls

import (
	"crypto/rand"

	blst "github.com/supranational/blst/bindings/go"
)

// Names in this file must be unique to support min-sig so we can't use 'dst'
// here.
var dstMinSig = []byte("BLS_SIG_BLS12381G1_XMD:SHA-256_SSWU_RO_NUL_")

//minimal-signature-size operations:
type PublicKeyMinSig = blst.P2Affine

type SignatureMinSig = blst.P1Affine

type AggregateSignatureMinSig = blst.P1Aggregate

type AggregatePublicKeyMinSig = blst.P2Aggregate

type Message = blst.Message

type SecretKey = blst.SecretKey

type Scalar = blst.Scalar

func GenRandomKeyMinSig() *SecretKey {
	// Generate 32 bytes of randomness
	var ikm [32]byte
	_, err := rand.Read(ikm[:])

	if err != nil {
		return nil
	}
	return blst.KeyGen(ikm[:])
}
